local mod = RW:Boss("Blood Prince Council", "Icecrown Citadel", "Icecrown Citadel", "The Crimson Hall")
local L

mod.BossIcon = [[Interface\Icons\achievement_boss_princetaldaram]]
mod.SubCatIcon = [[Interface\Icons\achievement_dungeon_crimsonhall]]

------------------------------------
-- Variables
-- Invocation of Blood
local tInvocationCD, wInvocation, iInvocation
-- Conjure Empowered Flame
local tEmpFlameCD, tEmpFlameCast, wEmpFlame
-- Empowered Shock Vortex
local tEmpShockCD, tEmpShockCast, wEmpShock
-- Shadow Resonance
local tShadwoResCD

-----------------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.name = "Blood Prince Council"
		
		L.Keleseth = "Keleseth"
		L.Taldaram = "Taldaram"
		L.Valanar = "Valanar"
		
		L.target_switch = "Target Switch possible"
		
		L.invocation_switch = "Switch to %s!"
		L.invocation_switch_opt = "Warning for when its time to switch target"
		
		L.shock_cast_warning = "Shock Vortex: Spread Out!"
	end
	L = mod:GetLocale()
	mod.L = L
	
	mod:SetTrigger(37973, 37972, 37970)
	mod:SetWin()
	
	self:AddToCategory(L.Valanar, 72039)
	self:AddToCategory(L.Taldaram, 72040)
	self:AddToCategory(L.Keleseth, 71943)
	
	-- General
	tInvocationCD		= self:CDTimer(33, L.target_switch, 70952)	
	wInvocation			= self:CustomWarning(L.invocation_switch, L.invocation_switch_opt, 70952)
	iInvocation			= self:Icon("SKULL", 70952)
	
	-- Taldaram
	tEmpFlameCD			= self:CDTimer(20, 72040)
	tEmpFlameCast		= self:CastTimer(72040)
	wEmpFlame			= self:CastWarning(72040)
	
	-- Valanar
	tEmpShockCD			= self:CDTimer(20, 72039)
	tEmpShockCast		= self:CastTimer(72039)
	wEmpShock			= self:RunawayWarning(L.shock_cast_warning, 72039)
	
	--Keleseth
	tShadwoResCD		= self:CDTimer(10, 71943)
end

-----------------------------------------
-- Locals
local TaldaramCID = 37973
local KelesethCID = 37972
local ValanarCID = 37970

-----------------------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("Invocation", 70952, 70981, 70982)
	self:Track("EmpShock", 72039)
	self:Track("EmpFlame", 72040)
	self:Track("ShadowRes", 71943)
	
	tInvocationCD:Start()
end

function mod:Invocation(event, args)
	if event == "SPELL_AURA_APPLIED" then
		local cID = self:CUIDFromGUID(args.dGUID)
		tInvocationCD:Start()
		wInvocation:Show(args.dName)
		
		if UnitName("boss1") == args.dName then
			iInvocation:Show("boss1")
		elseif UnitName("boss2") == args.dName then
			iInvocation:Show("boss2")
		elseif UnitName("boss3") == args.dName then
			iInvocation:Show("boss3")
		end		
		
		tEmpFlameCD:Stop()
		tEmpShockCD:Stopt()
		
		if cID == TaldaramCID then
			tEmpFlameCD:Start(7)
		elseif cID == KelesethCID then
		elseif cID == ValanarCID then
			tEmpShockCD:Start(7)
		end
	end
end

function mod:EmpShock(event, args)
	if event == "SPELL_CAST_START" then
		tEmpShockCD:Start()
		tEmpShockCast:Start()
		wEmpShock:Show()
	end
end

function mod:EmpFlame(event, args)
	if event == "SPELL_CAST_START" then
		tEmpFlameCD:Start()
		tEmpFlameCast:Start()
		wEmpFlame:Show()
	end
end

function mod:ShadowRes(event, args)
	if event == "SPELL_SUMMON" then
		tShadwoResCD:Start()
	end
end